routes/web.php
<?php

use App\Http\Controllers\VideoController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::middleware('auth')->group(function(){
    Route::get('/my-videos', [VideoController::class, 'myVideo'])->name('myVideo');
    
    Route::prefix('video')->name('video.')->group(function(){
        Route::get('/create', [VideoController::class, 'create'])->name('create');
        Route::post('/create', [VideoController::class, 'store'])->name('store');
        Route::get('/edit/{id}', [VideoController::class, 'edit'])->name('edit');
        Route::put('/update', [VideoController::class, 'update'])->name('update');
        Route::delete('/delete', [VideoController::class, 'delete'])->name('delete');
    });
});

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Models/Video.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Video extends Model
{
    use HasFactory;

    protected $fillable = [
        'title',
        'video_url',
        'thumbnail_url',
        'user_id',
        'date'
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Video;
use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $videos = Video::where('user_id', auth()->user()->id)->orderBy('created_at', 'DESC')->paginate(10);
        return view('videos.index', [
            'videos' => $videos
        ]);
    }
}

app/Http/Controllers/VideoController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreVideoRequest;
use App\Http\Requests\UpdateVideoRequest;
use App\Libs\UploaderLib;
use App\Models\Video;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class VideoController extends Controller
{
    public function myVideo()
    {
        $videos = Video::where('user_id', auth()->user()->id)->orderBy('created_at', 'DESC')->paginate(10);
        return view('videos.my-video', [
            'videos' => $videos
        ]);
    }

    public function create()
    {
        return view('videos.create');
    }

    public function store(StoreVideoRequest $request)
    {
        DB::beginTransaction();
        try {
            $file = UploaderLib::upload($request->file('video_file'));

            Video::create([
                'title' => $request->title,
                'video_url' => $file,
                'user_id' => auth()->user()->id,
                'date' => Carbon::now()
            ]);

            DB::commit();

            return redirect()->route('myVideo')->with('msg', 'Video uploaded successfully!');
        } catch (\Throwable $th) {
            DB::rollBack();
            
            return redirect()->back()->withInput()->with('error', $th->getMessage());
        }
    }

    public function edit($id)
    {
        $video = Video::findOrFail($id);
        return view('videos.edit', [
            'video' => $video
        ]);
    }

    public function update(UpdateVideoRequest $request)
    {
        DB::beginTransaction();
        try {
            $video = Video::find($request->id);
            if (!$video) {
                return redirect()->back()->withInput()->with('error', 'Video not found');
            }

            $file = $video->video_url;
            if ($request->file('video_file')) {
                $file = UploaderLib::upload($request->file('video_file'));
            }

            Video::where('id', $request->id)->update([
                'title' => $request->title,
                'video_url' => $file,
                'user_id' => auth()->user()->id,
                'date' => Carbon::now()
            ]);

            DB::commit();

            return redirect()->route('myVideo')->with('msg', 'Video uploaded successfully!');
        } catch (\Throwable $th) {
            DB::rollBack();
            
            return redirect()->back()->withInput()->with('error', $th->getMessage());
        }
    }

    public function delete(Request $request)
    {
        DB::beginTransaction();
        try {
            Video::where('id', $request->id)->delete();

            DB::commit();

            return redirect()->route('myVideo')->with('msg', 'Video deleted successfully!');
        } catch (\Throwable $th) {
            DB::rollBack();
            
            return redirect()->back()->withInput()->with('error', $th->getMessage());
        }
    }
}

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.bunny.net/css?family=Nunito" rel="stylesheet">
    <link rel="stylesheet" href="https://cdn.lineicons.com/3.0/lineicons.css"> 

    <!-- Scripts -->
    @vite(['resources/sass/app.scss', 'resources/js/app.js'])

    @yield('style')
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav me-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ms-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                                </li>
                            @endif

                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item">
                                <a class="nav-link btn btn-warning" href="{{ route('video.create') }}">{{ __('Upload Video') }} <i class="lnil lnil-add-file"></i></a>
                            </li>
                            <li class="nav-item ms-3 me-2" style="border-right: 1px solid #aaa;">
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('myVideo') }}">{{ __('My Video') }}</a>
                            </li>
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>

    @yield('script')
</body>
</html>

resources/views/videos/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <form method="POST" action="{{ route('video.store') }}" enctype="multipart/form-data">
            @csrf
            @include('components.alert')
            @if($errors->any())
                {!! implode('', $errors->all('<div class="col-12 alert alert-danger">:message</div>')) !!}
            @endif
            <div class="card">
                <div class="card-header">{{ __('Upload Your Video') }}</div>

                <div class="card-body">
                    <div class="row">
                        <div class="col-7">
                            <div class="mb-3">
                                <div class="mb-2">Title</div>
                                <input type="text" class="form-control" name="title" value="{{ $video->title ?? old('title') }}" />
                            </div>
                            <div>
                                <div class="mb-2">Video</div>
                                <input type="file" id="video-file" class="form-control" name="video_file" />
                            </div>
                        </div>
                        <div class="col-5">
                            <div class="thumbnail thumbnail-image-placeholder">
                                Preview
                            </div>
                            <video class="col-12 d-none" id="video-element" controls>
                                <source type="video/mp4">
                            </video>
                        </div>
                    </div>
                </div>

                <div class="card-footer">
                    <div class="col-12 text-end">
                        <button type="submit" class="btn btn-success">Upload Now!</button>
                    </div>
                </div>
            </div>
            </form>
        </div>
    </div>
</div>
@endsection

@section('script')
<script>
    const toBase64 = file => new Promise((resolve, reject) => {
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = () => resolve(reader.result);
        reader.onerror = error => reject(error);
    })
    
    document.querySelector("#video-file").addEventListener('change', function() {
        document.querySelector('#video-element').classList.remove('d-none')
        document.querySelector('.thumbnail-image-placeholder').classList.add('d-none')

        toBase64(document.querySelector("#video-file").files[0]).then(function(result){
            document.querySelector("#video-element source").setAttribute('src', result);
            document.querySelector("#video-element").load()
        })
    });
</script>
@endsection

resources/views/videos/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <form method="POST" action="{{ route('video.update') }}" enctype="multipart/form-data">
            @csrf
            @method('PUT')
            <input type="hidden" name="id" value="{{ $video->id }}" />
            @include('components.alert')
            @if($errors->any())
                {!! implode('', $errors->all('<div class="col-12 alert alert-danger">:message</div>')) !!}
            @endif
            <div class="card">
                <div class="card-header">{{ __('Upload Your Video') }}</div>

                <div class="card-body">
                    <div class="row">
                        <div class="col-7">
                            <div class="mb-3">
                                <div class="mb-2">Title</div>
                                <input type="text" class="form-control" name="title" value="{{ $video->title ?? old('title') }}" />
                            </div>
                            <div>
                                <div class="mb-2">Video</div>
                                <input type="file" id="video-file" class="form-control" name="video_file" />
                            </div>
                        </div>
                        <div class="col-5">
                            @if($video->video_url)
                            <video class="col-12" id="video-element" controls>
                                <source src="{{ $video->video_url }}" type="video/mp4">
                            </video>
                            @endif
                        </div>
                    </div>
                </div>

                <div class="card-footer">
                    <div class="col-12 text-end">
                        <button type="submit" class="btn btn-success">Update</button>
                    </div>
                </div>
            </div>
            </form>
        </div>
    </div>
</div>
@endsection

@section('script')
<script>
    const toBase64 = file => new Promise((resolve, reject) => {
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = () => resolve(reader.result);
        reader.onerror = error => reject(error);
    })
    
    document.querySelector("#video-file").addEventListener('change', function() {
        toBase64(document.querySelector("#video-file").files[0]).then(function(result){
            document.querySelector("#video-element source").setAttribute('src', result);
            document.querySelector("#video-element").load()
        })
    });
</script>
@endsection

resources/views/videos/index.blade.php
@extends('layouts.app')

@section('style')
<style>
    .video-player video{
        width: 100% !important;
    }

    .video-player .description small{
        color: #777;
    }

    .video-player .description .title{
        font-size: 18px;
    }
</style>
<link href="https://vjs.zencdn.net/7.20.3/video-js.css" rel="stylesheet" />
@endsection

@section('content')
<div class="container-fluid">
    <div class="row justify-content-center">
        <div class="col-12">
            @include('components.alert')

            @if(count($videos))
            <div class="row">
                @foreach($videos as $video)
                <div class="col-12 col-lg-4 mb-4 video-player">
                    <div class="card">
                        <video style="width: 100% !important;" class="video-js" controls preload="auto" data-setup="{}">
                            <source src="{{ $video->video_url }}" type="video/mp4" />
                            <p class="vjs-no-js">
                                To view this video please enable JavaScript, and consider upgrading to a
                                web browser that
                                <a href="https://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a>
                            </p>
                        </video>
                        <div class="description p-2">
                            <small>{{ \Carbon\Carbon::parse($video->date)->format('j F Y H:i') }}</small>
                            <div class="title">{{ $video->title }}</div>
                        </div>
                    </div>
                </div>
                @endforeach
            </div>
            @endif
        </div>
    </div>
</div>
@endsection

@section('script')
<script src="https://vjs.zencdn.net/7.20.3/video.min.js"></script>
@endsection

resources/views/videos/my-video.blade.php
@extends('layouts.app')

@section('style')
<style>
    .video-player video{
        width: 100% !important;
    }

    .video-player .description small{
        color: #777;
    }

    .video-player .description .title{
        font-size: 18px;
    }
</style>
<link href="https://vjs.zencdn.net/7.20.3/video-js.css" rel="stylesheet" />
@endsection

@section('content')
<div class="container-fluid">
    <div class="row justify-content-center">
        <div class="col-12">
            @include('components.alert')

            @if(count($videos))
            <div class="row">
                @foreach($videos as $video)
                <div class="col-12 col-lg-4 mb-4 video-player">
                    <div class="card">
                        <video style="width: 100% !important;" class="video-js" controls preload="auto" data-setup="{}">
                            <source src="{{ $video->video_url }}" type="video/mp4" />
                            <p class="vjs-no-js">
                                To view this video please enable JavaScript, and consider upgrading to a
                                web browser that
                                <a href="https://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a>
                            </p>
                        </video>
                        <div class="description p-2">
                            <small>{{ \Carbon\Carbon::parse($video->date)->format('j F Y H:i') }}</small>
                            <div class="title">{{ $video->title }}</div>
                        </div>
                        <div class="card-footer p-2 d-flex justify-content-end">
                            <a class="btn btn-danger me-auto" href="#" onclick="return (confirm('Are you sure want to delete this video?') ? document.querySelector('form#delete-{{ $video->id }}').submit() : false)">Delete</a>
                            <form action="{{ route('video.delete') }}" id="delete-{{ $video->id }}" method="POST">
                                @method('delete')
                                @csrf
                                <input hidden name="id" value="{{ $video->id }}" />
                            </form>

                            <a class="btn btn-warning" href="{{ route('video.edit', $video->id) }}">Edit</a>
                        </div>
                    </div>
                </div>
                @endforeach
            </div>
            @endif
        </div>
    </div>
</div>
@endsection

@section('script')
<script src="https://vjs.zencdn.net/7.20.3/video.min.js"></script>
@endsection